



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android系统中自定义按键的短按、双击、长按事件</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android系统中自定义按键的短按、双击、长按事件</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 11:13:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在项目中碰到这样的问题：&nbsp;<br />由于系统中的按键在底层做了重新定义或者新增了按键，此时需要在APP层对按键事件（keyevent）做分解处理，模拟Android系统做法，把keyevent分解成：&nbsp;<br />1、单击事件：就是普通key的单击；&nbsp;<br />2、双击事件：500ms内同一按键单击两次；&nbsp;<br />3、长按事件：同一按键长按超过1000ms（系统中长按事件为500ms）；&nbsp;<br />4、组合按键：两个以上按键同时按住；</p>
<p>其中的keyevent可以来自Activity、View子类的dispatchKeyEvent方法，也可以是我们自定义的接口，也可以是我们发广播送上来的，根据项目需求；</p>
<p>关于各事件的原理：&nbsp;<br />1、双击事件：每次点击的up事件中启动一个定时（500ms）线程消息，用Handler.postDelayed()方法。&nbsp;<br />2、长按事件：每次点击的down事件中启动一个定时（1000ms）线程消息，用Handler.postDelayed()方法，注意：在RepeatCount==0时启动；&nbsp;<br />3、组合按键：用变量记录每个按键的状态，再进行判断；</p>
<p>具体代码如下：&nbsp;Java代码</p>
<div>
<pre class="prettyprint linenums">package com.jerome.util;

import android.content.Context;<br />
import android.os.Handler;<br />
import android.util.Log;<br />
import android.view.KeyEvent;

public class KeyUtil {<br />
	private boolean isVolumeDown = false;<br />
	private boolean isVolumeUp = false;<br />
	private boolean isMenu = false;<br />
	private int currentKeyCode = 0;

	private static Boolean isDoubleClick = false;<br />
	private static Boolean isLongClick = false;

	CheckForLongPress mPendingCheckForLongPress = null;<br />
	CheckForDoublePress mPendingCheckForDoublePress = null;<br />
	Handler mHandler = new Handler();

	Context mContext = null;<br />
	private String TAG = "";

	public KeyUtil(Context context, String tag) {<br />
		mContext = context;<br />
		TAG = tag;<br />
	}

	public void dispatchKeyEvent(KeyEvent event) {<br />
		int keycode = event.getKeyCode();

		// 有不同按键按下，取消长按、短按的判断<br />
		if (currentKeyCode != keycode) {<br />
			removeLongPressCallback();<br />
			isDoubleClick = false;<br />
		}

		// 处理长按、单击、双击按键<br />
		if (event.getAction() == KeyEvent.ACTION_DOWN) {<br />
			checkForLongClick(event);<br />
		} else if (event.getAction() == KeyEvent.ACTION_UP) {<br />
			checkForDoubleClick(event);<br />
		}

		if (keycode == KeyEvent.KEYCODE_VOLUME_DOWN) {<br />
			if (event.getAction() == KeyEvent.ACTION_DOWN) {<br />
				isVolumeDown = true;<br />
			} else if (event.getAction() == KeyEvent.ACTION_UP) {<br />
				isVolumeDown = false;<br />
			}<br />
		} else if (keycode == KeyEvent.KEYCODE_VOLUME_UP) {<br />
			if (event.getAction() == KeyEvent.ACTION_DOWN) {<br />
				isVolumeUp = true;<br />
			} else if (event.getAction() == KeyEvent.ACTION_UP) {<br />
				isVolumeUp = false;<br />
			}<br />
		} else if (keycode == KeyEvent.KEYCODE_MENU) {<br />
			if (event.getAction() == KeyEvent.ACTION_DOWN) {<br />
				isMenu = true;<br />
			} else if (event.getAction() == KeyEvent.ACTION_UP) {<br />
				isMenu = true;<br />
			}<br />
		}

		// 判断组合按键<br />
		if (isVolumeDown<br />
				&amp;&amp; isVolumeUp<br />
				&amp;&amp; isMenu<br />
				&amp;&amp; (keycode == KeyEvent.KEYCODE_VOLUME_UP<br />
						|| keycode == KeyEvent.KEYCODE_VOLUME_DOWN || keycode == KeyEvent.KEYCODE_MENU)<br />
				&amp;&amp; event.getAction() == KeyEvent.ACTION_DOWN) {<br />
			//组合按键事件处理；<br />
			isVolumeDown = false;<br />
			isVolumeUp = false;<br />
			isMenu = false;<br />
		}<br />
	}

	private void removeLongPressCallback() {<br />
		if (mPendingCheckForLongPress != null) {<br />
			mHandler.removeCallbacks(mPendingCheckForLongPress);<br />
		}<br />
	}

	private void checkForLongClick(KeyEvent event) {<br />
		int count = event.getRepeatCount();<br />
		int keycode = event.getKeyCode();<br />
		if (count == 0) {<br />
			currentKeyCode = keycode;<br />
		} else {<br />
			return;<br />
		}<br />
		if (mPendingCheckForLongPress == null) {<br />
			mPendingCheckForLongPress = new CheckForLongPress();<br />
		}<br />
		mPendingCheckForLongPress.setKeycode(event.getKeyCode());<br />
		mHandler.postDelayed(mPendingCheckForLongPress, 1000);<br />
	}

	class CheckForLongPress implements Runnable {

		int currentKeycode = 0;

		public void run() {<br />
			isLongClick = true;<br />
			longPress(currentKeycode);<br />
		}

		public void setKeycode(int keycode) {<br />
			currentKeycode = keycode;<br />
		}<br />
	}

	private void longPress(int keycode) {<br />
		Log.i(TAG, "--longPress 长按事件--" + keycode);<br />
	}

	private void singleClick(int keycode) {<br />
		Log.i(TAG, "--singleClick 单击事件--" + keycode);<br />
	}

	private void doublePress(int keycode) {<br />
		Log.i(TAG, "---doublePress 双击事件--" + keycode);<br />
	}

	private void checkForDoubleClick(KeyEvent event) {<br />
		// 有长按时间发生，则不处理单击、双击事件<br />
		removeLongPressCallback();<br />
		if (isLongClick) {<br />
			isLongClick = false;<br />
			return;<br />
		}

		if (!isDoubleClick) {<br />
			isDoubleClick = true;<br />
			if (mPendingCheckForDoublePress == null) {<br />
				mPendingCheckForDoublePress = new CheckForDoublePress();<br />
			}<br />
			mPendingCheckForDoublePress.setKeycode(event.getKeyCode());<br />
			mHandler.postDelayed(mPendingCheckForDoublePress, 500);<br />
		} else {<br />
			// 500ms内两次单击，触发双击<br />
			isDoubleClick = false;<br />
			doublePress(event.getKeyCode());<br />
		}<br />
	}

	class CheckForDoublePress implements Runnable {

		int currentKeycode = 0;

		public void run() {<br />
			if (isDoubleClick) {<br />
				singleClick(currentKeycode);<br />
			}<br />
			isDoubleClick = false;<br />
		}

		public void setKeycode(int keycode) {<br />
			currentKeycode = keycode;<br />
		}<br />
	}

	private void removeDoublePressCallback() {<br />
		if (mPendingCheckForDoublePress != null) {<br />
			mHandler.removeCallbacks(mPendingCheckForDoublePress);<br />
		}<br />
	}<br />
}
</pre>
</div>
<p>　　注意：&nbsp;<br />只有Action Down状态下RepeatCount才会&gt;0，避免长按和单击事件混淆；</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyynexq.html">cordova plugin add出现CERT&lowbar;UNTRUSTED错误解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnd0w38.html">深入研究java&period;lang&period;Runtime类</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j21ww8.html">SE Homework 1 &mdash;An Error Impressed Me</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g5xnl8.html">CSS code</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwn76zq.html">js获取当前时间显示在页面上</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g7rrl9.html">cadence学习之原理图&mdash;&mdash;连线</a>
		</li>
						<li><a href="https://www.batexi.com/a/49goyr7q.html">tomcat部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv6jvo8.html">MVC5 &plus; EF6 &plus; Bootstrap3 &lpar;8&rpar; HtmlHelper用法大全&lpar;上&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1mkzr9.html">模拟&plus;思维 HDOJ 5319 Painter</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zj7x09.html">c&plus;&plus;11之右值引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zyol69.html">BroadcastReceiver</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1x6138.html">HDU 3572 最大流</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mej0ooq.html">Velocity China 2016 Web 性能与运维大会：构建快速、可扩展的弹性网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj5n0l8.html">IOS开发－UI学习－UIWebView，简单浏览器的制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pko038.html">&lbrack;Python Study Notes&rsqb;进程信息&lpar;丁丁软件监控进程&comma;http-post&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdoo6k9.html">HTML学习笔记3：文字和段落</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp6vdjq.html">TCP 服务端接收数据解析工具类</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wy32gq.html">gradle用户目录本地库移动设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllv676q.html">ant常用的内置 task转自https&colon;&sol;&sol;www&period;cnblogs&period;com&sol;baicj&sol;archive&sol;2015&sol;12&sol;21&sol;5063608&period;html</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvlzx28.html">由内省引出JavaBean的讲解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4mzd3q.html">completionService</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1pk24q.html">python学习道路&lpar;day3note&rpar;&lpar;元组，字典 ，集合，字符编码，文件操作&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2mjvl8.html">&lpar;TODO&colon;&rpar;下载图片&comma;报错&colon;warning&colon; could not load any Objective-C class information from the dyld shared cache&period; This will significantly reduce the quality of type information available&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7lo6e8.html">关于 Pragma 的使用总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlnn2x8.html">iOS 面试题（三）：为什么 weakSelf 需要配合 strong self 使用 --转自唐巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/495mj76q.html">Linux 利用进程打开的文件描述符&lpar;&sol;proc&rpar;恢复被误删文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pkx5k8.html">scrollViewDidEndScrollingAnimation和scrollViewDidEndDecelerating的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/m967ymn8.html">【杂记】Asp&period;Net 篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pk2x48.html">IOS轮播图</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvz3lo9.html">关于跨域GET、POST请求的小结&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;&sol;zzzzzzz</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
